from Products.PloneStickies import stickies_globals
from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.Archetypes import public as atapi

import Products.PloneStickies.config as stickies_config

SKIN_NAME = "stickies"
_globals = globals()

def install_tools(self, out):
    if not hasattr(self, stickies_config.TOOL_NAME):
        addTool = self.manage_addProduct[stickies_config.PROJECTNAME].manage_addTool
        addTool(stickies_config.TOOL_TITLE)

def install_actions(self, out):
    """
    I don't actually think i will provide any actions, but i might...
    maybe, document actions, right where print and send to a friend are "annotate me"
    """
    at = getToolByName(self, "portal_actions")
    if not hasattr(at, 'stickynote'):
        at.addAction('stickynote',
                     'Sticky Note for AT Content',
                     "string:javascript:showSticky('sticky-view');",
                     "python:  not portal.portal_membership.isAnonymousUser() and hasattr(object, 'UID')",                     
                     'View',
                     'document_actions',
                     1)

    try:
        ai=getToolByName(self, 'portal_actionicons')
        ai.addActionIcon('plone', 'stickynote', 'sticky_icon.gif', 'Sticky-Note')
    except:
        print >> out, "Icon already added to actionicons tool"

def install_indexes(self, out):
    """
    its nice having uids in the main catalog
    """
    catalog = getToolByName(self, 'portal_catalog')
    try:
        catalog.addIndex('UID', 'FieldIndex', extra=None)
    except:
        pass

    try:
        if not 'UID' in catalog.schema():
            catalog.addColumn('UID')
    except:
        print >> out, ''.join(traceback.format_exception(*sys.exc_info()))
        print >> out, "Problem updating catalog for UIDs"

    try:
        catalog.manage_reindexIndex(ids=('UID',))
    except:
        pass


def install(self):
    out = StringIO()
    print >>out, "Installing PloneStickies"

    install_tools(self, out)
    install_subskin(self, out, stickies_config.GLOBALS)
    install_indexes(self, out)
    installTypes(self, out, atapi.listTypes(stickies_config.PROJECTNAME), stickies_config.PROJECTNAME)
    # none, for now - see comment 
    install_actions(self, out)
    install_subskin(self, out)
    return out.getvalue()


