from AccessControl import ClassSecurityInfo
from Products.Archetypes import public as atapi
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import getToolByName

from Products.Archetypes.debug import log
from Products.PloneStickies import config

schema = atapi.BaseSchema + atapi.Schema((
    atapi.TextField(name='note',
                    searchable=1,
                    default_content_type = 'text/structured',
                    default_output_type = 'text/html',
                    widget = atapi.TextAreaWidget(label="Note",),
                    allowable_content_types=('text/structured',)
                    ),
	))

class Sticky(atapi.BaseContent):
    security=ClassSecurityInfo()
    schema = schema
    portal_type = meta_type = archetype_name = "Sticky"
    content_icon = "sticky_icon.gif"

    global_allow = True

    actions = (
        {
        'id' : 'view',
        'name' : 'view',
        'action' : 'string:${object_url}/sticky_view',
        'permissions' : (CMFCorePermissions.View,),
        },
        )


    security.declarePublic("getRawNote")
    def getRawNote(self):
        """
        convinience method for getting raw note
        """
        note = getattr(self, 'note', None)
        if note:
            raw = note.getRaw()
        else:
            raw = None
        return raw

    security.declarePublic("getReviewState")
    def getReviewState(self):
		"""
		convinience method for getting the stickie's state off the wf tool
		"""
		w_tool = getToolByName(self, 'portal_workflow')
		return w_tool.getInfoFor(self, 'review_state', None)

    security.declarePublic("getTarget")
    def getTarget(self):
        """
        convinience method for object I am stuck to
        """
        # notes are attached to a single target, so the first ref is the one we want
        try:
            target = self.getRefs(relationship = config.STICKY_RELATIONSHIP)[0]
        except Exception, e:
            log("Couldn't find the target of this sticky (%s (%s))!\n%s" % (self.id, self.Title, e))
            target = None

        return target
    
atapi.registerType(Sticky, config.PROJECTNAME)

